function insert(item, user, request) {
    var userId = user.userId;
    
    if (user.getIdentities().twitter) {
        var twitterId = userId.substring(userId.indexOf(':') + 1);
        
        var url = 'https://api.twitter.com/1/users/lookup.json?user_id=' + twitterId;
        
        var req = require('request');
        req(url, function(err, resp, body) {
            var userData = JSON.parse(body);
            
            item.sender = userData[0].name;
            item.pictureUrl = userData[0].profile_image_url_https;
            
            request.execute({ 
                success: function() {
                    request.respond();
                    handleNotifications(item);
                },
                error: function(error) { 
                  console.log(error); 
                  request.respond(); 
                } 
              }); 
        });  
    }
}

function handleNotifications(item) {
    var channels = tables.getTable('PushChannels');
    
    channels.read({
        success: function(results) {
            results.forEach(function(element) {
                if (element.Type === 'W8') {
                    // push to W8 client
                    console.log('Push su Win8');
                    push.wns.sendToastImageAndText02(element.Data, {
                        text1:item.sender,
                        text2:item.body,
                        image1src:item.pictureUrl
                    });
                } else if (element.Type === 'WP8') {
                    // push to WP8 client
                    console.log('Push su Wp8');
                    push.mpns.sendToast(element.Data, {
                        text1:item.sender,
                        text2:item.body
                    }, {
                       error: function(err) {
                           console.log(err);
                       },
                       success: function() {
                           console.log('ok to WP8');
                       }
                    });
                } else if (element.Type === 'iOS') {
                    // push to iOS client
                    console.log('Push su iOS');
                    push.apns.send(element.Data, {
                        alert: item.body
                    }, {
                        error: function(err) {
                           console.log(err);
                       },
                       success: function() {
                           console.log('ok to iOS');
                       }
                    });
                }
            }, this);
        }
    });
}