﻿using System.Windows.Input;
using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Command;
using wAzureAppWin8.ObjectModel;

namespace wAzureAppWin8.ViewModel
{
    public class AccountSettingsViewModel : ViewModelBase
    {
        private ICommand _twitterLogin;
        public ICommand TwitterLogin
        {
            get
            {
                if (_twitterLogin == null)
                {
                    _twitterLogin = new RelayCommand(async () => 
                    {
                        await AuthenticationHelper.Instance.LoginAsync();
                    });
                }

                return _twitterLogin;
            }
        }

        private ICommand _logout;
        public ICommand Logout
        {
            get
            {
                if (_logout == null)
                {
                    _logout = new RelayCommand(() => 
                    {
                        AuthenticationHelper.Instance.Logout();
                    });
                }

                return _logout;
            }
        }
    }
}
