﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Command;
using Microsoft.WindowsAzure.MobileServices;
using wAzureAppWin8.ObjectModel;
using Windows.UI.Popups;

namespace wAzureAppWin8.ViewModel
{
    public class NewMessageViewModel : ViewModelBase
    {
        private IMobileServiceTable<Message> _table;
        private Action _refresh;

        public NewMessageViewModel(Action refresh)
        {
            _table = App.MobileService.GetTable<Message>();
            _refresh = refresh;
        }

        private string _body = string.Empty;
        public string Body
        {
            get { return _body; }
            set { this.Set("Body", ref _body, value); }
        }

        private ICommand _send;
        public ICommand Send
        {
            get
            {
                if (_send == null)
                {
                    _send = new RelayCommand(() => this.SendMessage());
                }

                return _send;
            }
        }

        private async void SendMessage()
        {
            try
            {
                if (string.IsNullOrWhiteSpace(this.Body))
                    return;

                var message = new Message()
                {
                    Body = this.Body
                };

                await _table.InsertAsync(message);

                _refresh();
            }
            catch (Exception)
            {
                new MessageDialog("Errore durante la richiesta").ShowAsync();
            }
        }
    }
}
