//
//  MessageCellView.m
//  wazureapp
//
//  Created by Marco De Sanctis on 30/12/12.
//  Copyright (c) 2012 Marco De Sanctis. All rights reserved.
//

#import "MessageCellView.h"

@implementation MessageCellView

NSURLConnection* connection;

@synthesize sender;
@synthesize image;
@synthesize body;

- (void)didMoveToWindow {
    [self.body sizeToFit];
}

- (id)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {
        // Initialization code
    }
    return self;
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated
{
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

- (void)setImageUrl:(NSString*)url {
    if (connection != nil) {
        [connection release];
        connection = nil;
    }
    
    if ((NSNull *) url == [NSNull null] ||
        url == nil || url.length == 0) {
        return;
    }
    
    NSURLRequest *request = [NSURLRequest requestWithURL:[NSURL URLWithString:url] cachePolicy:NSURLCacheStorageAllowed timeoutInterval:60.0];
    
    connection = [[NSURLConnection alloc] initWithRequest:request
                                                 delegate:self startImmediately:true];
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
    UIImage *loadedImage = [[UIImage alloc] initWithData:data];
    
    self.image.image = loadedImage;
    
    [loadedImage release];
    
}

- (NSString *) reuseIdentifier {
    return @"theCell";
}

-(void)dealloc {
    [sender release];
    [image release];
    [body release];
    
    [super dealloc];
}

@end
